package com.kob.backend.controller.user;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.kob.backend.mapper.UserMapper;
import com.kob.backend.pojo.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

//实现对用户类 User 的增删查操作->这个类仅用于调试,故 Deparecated 掉
@Deprecated
@RestController
public class UserController {

//    用到数据库里的 Mapper 时,需要加 @Autowired 注解
    @Autowired
    UserMapper userMapper;

//    返回所有用户
    @GetMapping("/user/all")
    public List<User> getAll() {
//      null 表示查询所有的
        return userMapper.selectList(null);
    }

/*
    @GetMapping("/user/{userId}/")
    public User getUser(@PathVariable int userId) {
//        查询某个用户
//        return userMapper.selectById(userId);

//        封装查询语句:查询某个 id 的用户
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", userId);
        return userMapper.selectOne(queryWrapper);
    }
*/

    @GetMapping("/user/{userId}")
    public List<User> getUser(@PathVariable int userId) {
//        封装查询语句:查询某个范围 id 的用户: ge 是大于等于, gt 是大于, le 是小于等于, lt 是小于
        QueryWrapper<User> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.ge("id", 2).le("id", 4);
        return userMapper.selectList(queryWrapper1);
    }

    @GetMapping("/user/add/{userId}/{username}/{password}")
    public String addUser(@PathVariable int userId,
                          @PathVariable String username,
                          @PathVariable String password) {
        if(password.length() < 6){
            return "密码少于6位,请重设密码";
        }
//        加密明文密码并存入密文到数据库
        PasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        String encodedPassword = passwordEncoder.encode(password);
        User user = new User(userId, username, encodedPassword,"");
        userMapper.insert(user);
        return "Add User Successfully";
    }

    @GetMapping("/user/delete/{userId}")
    public String deleteUser(@PathVariable int userId){
        userMapper.deleteById(userId);
        return "Delete User Successfully";
    }
}
