package com.kob.backend.service.impl.utils;

import com.kob.backend.pojo.User;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import java.util.Collection;

//实现 UserDetails 接口:需要加上 lombok 的注解,来自动生成构造函数
@Data
@AllArgsConstructor
@NoArgsConstructor
public class UserDetailsImpl implements UserDetails {

//    定义一个 pojo 的 User 类对象
    private User user;

    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        return null;
    }

//    获取 pojo -> User 类对象 user 的用户密码
    @Override
    public String getPassword() {
        return user.getPassword();
    }

//    获取 pojo -> User 类对象 user 的用户名
    @Override
    public String getUsername() {
        return user.getUsername();
    }

//    用户账号是否没有过期
    @Override
    public boolean isAccountNonExpired() {
        return true;
    }

//    用户是否没有被锁定
    @Override
    public boolean isAccountNonLocked() {
        return true;
    }

//    用户授权是否没有过期
    @Override
    public boolean isCredentialsNonExpired() {
        return true;
    }

//    用户是否被启用
    @Override
    public boolean isEnabled() {
        return true;
    }
}
