// 定义墙组件
import { AcGameObject } from "./AcGameObject";

export class Wall extends AcGameObject {
  // 构造函数定义,参数为墙的坐标 r 行, c 列,gamemap 用于绘制
  constructor(r, c, gamemap) {
    // 先执行基类的构造函数
    super();

    this.r = r;
    this.c = c;
    this.gamemap = gamemap;
    this.color = "#b47226";
  }

  // 墙的更新
  update() {
    // 执行渲染
    this.render();
  }

  // 墙的渲染
  render() {
    // 从 gamemap 对象中拿到小格(墙)的边长
    const L = this.gamemap.L;

    // 拿到ctx画布
    this.ctx = this.gamemap.ctx;

    // 设置 ctx 画布填充色
    this.ctx.fillStyle = this.color;
    // 绘制矩形
    this.ctx.fillRect(this.c * L, this.r * L, L, L);
  }
}
